
#ifndef _GENERAL_H_
#define _GENERAL_H_

// General includes
#include <gtk/gtk.h>

#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>

// Local includes
#include "lintar_global.h"
#include "extract_dialog.h"
#include "prefs_dialog.h"
#include "prog.h"


const char* gnome_vfs_mime_type_from_name   (const char *filename);
const char* gnome_vfs_get_file_mime_type    (const char *path,
                                             const struct stat *optional_stat_info,
                                             gboolean suffix_only);


/* Proto definitions */
void lintar_destroy_all(void);
void lintar_callback_action(gchar *action);
GdkPixbuf *lintar_get_pixbuf_from_file( GtkWidget *window, 
										guint8 type,
										gchar *fullname);
void lintar_set_widgets_sensitive(gboolean b);
void lintar_notebook_add_page( GtkWidget *sw, gchar *file);
void lintar_select_notebook_current_page( void);

void lintar_get_full_filename( gchar *output, gchar *shortname, gchar **fullname);
void lintar_extract_symbolic_link( gchar *output, gchar *filename, gchar **link, guint8 *type);
void lintar_remove_directory( gchar *permissions, gchar *name, guint8 *type);
guint8 lintar_get_compress_file_type( gchar *file);

gpointer thread_wait(gpointer data);
gboolean thread_g_spawn_sync(const gchar *working_directory,
							 gchar **argv,
							 gchar **envp,
							 GSpawnFlags flags,
							 GSpawnChildSetupFunc child_setup,
							 gpointer user_data,
							 gchar **standard_output,
							 gchar **standard_error,
							 gint *exit_status,
							 GError **error);

GtkItemFactory *lintar_create_popup_menu(void);
void view_selected_files(gboolean recursive);

gboolean copy_file( gchar *from, gchar *to, gboolean overwrite);


#endif /*_GENERAL_H_ */
